#Forplay
reset()
set_random_seed(52836);

import os

import scipy
from scipy import optimize

import numpy
from numpy import linalg

from sage.misc.decorators import infix_operator
@infix_operator('multiply')
def dot(a,b) : return vector([a[i]*b[i] for i in range(0,min(len(a),len(b)))])

#Actual Stuff

p = 3

#This is a unique way of addressing E_ijk
def var_name(_k) : 
    k=_k
    k.sort()
    return ("e"+join(map(str,k),""))

#Make the list of possible E for this dimension
v_var = reduce(lambda u,v : u+" "+v,list(set([var_name([j,k,l]) for j in range(0,p) for k in range(0,p) for l in range(0,p)])))
var(v_var)
v_vlist = eval(v_var.replace(" ",","))

#These are the ways of simplifying the various e_vars with things that we know from the fact that the prototype is an element of O(n,C)
#e_00k=e_0k=e_k=0
simp_1 = {eval(var_name([0,0,k])):0 for k in range(1,p)}
#The e_0jk= e_jk = delta(j,k)
simp_2 = {eval(var_name([0,k,k])):1 for k in range(1,p)}
simp_3 = {eval(var_name([0,j,k])):0 for j in range(1,p) for k in range(1+j,p)}

#This is the matrix A_jk = e_jnk where n is fixed
def A(n) : return matrix( [[eval(var_name([n,j,k])) for j in range(0,p)] for k in range(0,p)]).subs(simp_1).subs(simp_2).subs(simp_3)

#In this example we care only about the first two coordinates of the sigma points
print("This is the A matrix about sigma point^t 1")
print(A(1))

print("The next question is how far can we push the accuracy of a single state with 4 sigma points")
what_we_want = {e111:0}
print("This is the base A1")
print(A(1).subs(what_we_want))
print("We want the [1,1] element of A11 to be 3 or that,")
eq1 = (A(1)*A(1)).subs(what_we_want)[1,1]-3
print(eq1)
print("This is easily solveable with e112:sqrt(2)")
print("The [1,1] element of A111, E11111 should be zero")
eq2 = (A(1)*A(1)*A(1)).subs(what_we_want).subs({e112:sqrt(2)})[1,1]
print(eq2)

print("The resulting A1 Matrix would be")
sol_subs = {e112:sqrt(2),e122:0}
tA1 = A(1).subs(what_we_want).subs(sol_subs)
print(tA1)
teig = linalg.eig(tA1.n())
print("The sigma point prototype")
print(matrix(teig[1]))
print("And the actual sigma points")
w_root=matrix(teig[1])[0]
w_root_i=w_root.apply_map(lambda u : 1/u)
print("Weight Vector " + str(w_root *dot* w_root))
print("Y1 " + str(matrix(teig[1])[1] *dot* w_root_i))
tSP = matrix(teig[1])
