reset()

import os

from sage.misc.decorators import infix_operator
@infix_operator('multiply')
def dot(a,b) : return vector([a[i]*b[i] for i in range(0,min(len(a),len(b)))])

def E(d,k,j) :
    ee = matrix(QQ,d)
    ee[k,j]=1
    return ee

def G(n,j,k,theta) : return (cos(theta)-1)*(E(n,j,j)+E(n,k,k))+sin(theta)*(-E(n,j,k)+E(n,k,j)) + matrix.identity(n)

def Jacobi_Method(M) :
    tM = M.__copy__()
    R = identity_matrix(p).n()
    for iter in range(0,100) :
        M_abs = tM.apply_map(abs)
        for k in range(0,p) :
            M_abs[k,k] = 0
        mele = max(M_abs.list())
        if(max(M_abs.list())<0.00001) : return(R.transpose(),tM)
        pivot = M_abs.list().index(max(M_abs.list()))
        p_j = floor(pivot/p)
        p_k = pivot%p
        dev = tM[p_k,p_k] - tM[p_j,p_j]
        if abs(dev)<0.001 : dev = 0.001
        theta = (atan(2*tM[p_j,p_k]/dev)/2).n()
        tR = G(p,p_j,p_k,theta).n()
        tM = tR*tM*tR.transpose()
        R = tR*R
    return(R.transpose(),tM)

#Actual Stuff

p = 4

#This is a unique way of addressing E_ijk
def var_name(_k) :
    k=_k
    k.sort()
    return ("e"+join(map(str,k),""))

#Make the list of possible E for this dimension
v_var = reduce(lambda u,v : u+" "+v,list(set([var_name([j,k,l]) for j in range(0,p) for k in range(0,p) for l in range(0,p)])))
var(v_var)
v_vlist = eval(v_var.replace(" ",","))

#These are the ways of simplifying the various e_vars with things that we know from the fact that the prototype is an element of O(n,C)
#e_00k=e_0k=e_k=0
simp_1 = {eval(var_name([0,0,k])):0 for k in range(1,p)}
#The e_0jk= e_jk = delta(j,k)
simp_2 = {eval(var_name([0,k,k])):1 for k in range(1,p)}
simp_3 = {eval(var_name([0,j,k])):0 for j in range(1,p) for k in range(1+j,p)}

#This is the matrix A_jk = e_jnk where n is fixed
def A(n) : return matrix( [[eval(var_name([n,j,k])) for j in range(0,p)] for k in range(0,p)]).subs(simp_1).subs(simp_2).subs(simp_3)

#In this example we care only about the first two coordinates of the sigma points
print("This is the A matrix about sigma point^t 1")
print(A(1))

var('v')
A1 = A(1)
A11 = A1*A1
A111 = A1*A1*A1
print("A11")
print(A11)
print("A111")
print(A111)

A2 = A(2)
A12 = A1*A2
A22 = A2*A2

eqs_we_need = [
#From the Symmetry Matrix
    A12[1,2]-A12[2,1], # A1*A2 = A2*A1 this is the only thing that remains from this
    A12[1,3]-A12[3,1],
    A12[2,3]-A12[3,2],
#From the Zero Cross Terms
    A1[1,2], # The term E112 must be zero
    A1[2,2], # The term E122 must be zero
    A12[1,1], # The term E1112 must be zero so it doesn't contribute anything
    A12[2,2], # The term E1222 must be zero so it doesn't contribute anything
#Symmetry
    A11[1,1]-A22[2,2], # The terms E1111=E2222 so when we stack we dont have to keep track of the unbalanced symmetry
    A1[1,1]-A2[2,2] # Same as above
]

needed_vars = list(Set(reduce(lambda u,v:u+v,map(lambda u:u.variables(),eqs_we_need))))

macaulay2.restart()
macaulay2.eval("R = QQ"+str(needed_vars))
filename = tmp_filename(ext=".m2")
f=open(filename,'w')
f.write("J1 = ideal"+str(tuple(eqs_we_need)))
f.close()
print(macaulay2.eval("load(\""+filename+"\")"))
os.unlink(filename)
print(macaulay2.eval("gens gb J1"))

print("From this we know e112=e122=0")
tA1 = A1.subs({e112:0,e122:0})
print("A1")
print(tA1)
print("A11")
print(tA1*tA1)
print("We want the term A11[2,2]=e123^2 to be nonzero and from before we know e113*e123=0 so e113=0")

eqs_lvl2 = eqs_we_need+[e113]

#macaulay2.restart()
#macaulay2.eval("R = QQ"+str(needed_vars))
filename = tmp_filename(ext=".m2")
f=open(filename,'w')
f.write("J = ideal"+str(tuple(eqs_lvl2)))
f.close()
print(macaulay2.eval("load(\""+filename+"\")"))
os.unlink(filename)
print(macaulay2.eval("gens gb J"))

print("e123=1")
tA1 = tA1.subs({e123:1,e113:0})
print("A1")
print(tA1)
print("A11")
print(tA1*tA1)
print("A111")
print(tA1*tA1*tA1)
print("So the easiest thing is that e111=e133=0 and we have 5th order moments correct")
tA1 = tA1.subs({e111:0,e133:0})
print("A1")
print(tA1)

(r,d) = Jacobi_Method(tA1.n())
print("Prototype")
print(r)
print("Which looks unusable until we realize that we can mix eigenvectors with the same eigenvalue")
print("Eigenvalues")
print(d.diagonal())
T = matrix([
    [1/2,0,1/2,0],
    [1/2,0,-1/2,0],
    [0,-1/2,0,-1/2],
    [0,1/2,0,-1/2]
])*sqrt(2).n()
print("Mixing Matrix")
print(T)
print("New Prototype")
r = T*r
print(r)
w_root_i = r[0].apply_map(lambda u : 1/u)
print("W")
print( (r[0]*dot*r[0]).n(digits=3) )
print("Y1")
print( (r[1]*dot*w_root_i).n(digits=3))
print("Y2")
print( (r[2]*dot*w_root_i).n(digits=3))
