reset()

import matplotlib
matplotlib.use('SVG')
matplotlib.rc('font',family='M+ 2p',weight='light')
import matplotlib.pyplot as plt

fig = plt.figure()
fig.set_figwidth(7)
fig.set_figheight(4)
axs = fig.add_axes( ((0.6)/7, (0.4)/4, 1-.8/7, 1-.6/4) )

axs.set_xlabel('Value')
axs.set_ylabel('Probability Density')

v1 = [k/100 for k in range(1,600)]
chi2_v = map(lambda x : exp(-x/2)/sqrt(2*pi*x),v1)
v2 = [k/100 for k in range(-200,600)]
norm_v = map(lambda x : exp(-1/8*(x-1)^2)/sqrt(2*pi)/2,v2)
norm2_v = map(lambda x : exp(-1/2*(x)^2/0.1^2)/sqrt(2*pi)/0.1,v2)
chi2, = axs.plot(v1,chi2_v,'-',color='#cc0000')
norm, = axs.plot(v2,norm_v,'-',color='#336633')
norm2, = axs.plot(v2,norm2_v,'-',color='#336699')

axs.legend( (chi2,norm2,norm) , ("True Chi Squared","Normal (0,0.01)","Normal (1,2)"), framealpha=0.7, numpoints=1, prop={"family":"M+ 2p","weight":"ultralight","size":8})

yticks = [0,0.1,0.2,0.3,0.4,0.5]
axs.set_yticks(yticks)
xticks = [-2,0,2,4,6]
axs.set_xticks(xticks)
axs.set_ylim(0,0.5)
axs.grid(True)

fig.savefig('Plots/Chi2vsNormal.svg')
plt.close(fig)
