#ifndef SPACE_H_
#define SPACE_H_
#include "BlindTricycle.h"
#include <string.h>

const NT dt = 0.5;
const NT bw = 1.25;
const NT br = 0.30;

const MERRY_GO_ROUND merrys[2] {
	{7.5,0,-15},
	{6.5,2,15}
};

vec<7> moveForward(mat<7,7> *, mat<7,5> *, const vec<7> &, const vec<5> &, TRICYCLE_FORCING *);
vec<1> observer1(mat<1,7> *, mat<1,2> *, const vec<7> &, const vec<2> &, MERRY_FORCING *);
vec<1> observer2(mat<1,7> *, mat<1,2> *, const vec<7> &, const vec<2> &, MERRY_FORCING *);

template <unsigned short n>
int read_in_vfile(vec<n> **vlist, const char *filename){
	FILE *fp;
	int nlines;

	char instring[MAX_INPUT];
	char *tstring;

	float tval;
	NT tvec[n];

	fp = fopen(filename,"r");
	if (!fp) {
		printf("Failed to open the file %s\n",filename);
		return 0;
	}

	nlines = 0;
	while(!feof(fp)) {
		nlines++;
		fgets(instring,MAX_INPUT,fp);
	}
	nlines--;

	rewind(fp);

	*vlist = (vec<n>*)malloc(nlines*sizeof(vec<n>));

	for (int i=0;i<nlines;i++){
		fgets(instring,MAX_INPUT,fp);
		tstring = strtok(instring," ");
		for(int j=0;j<n;j++){
			sscanf(tstring,"%f",&tval);
			tvec[j] = tval;
			tstring = strtok(NULL," \0");
		}
		(*vlist)[i] = vec<n>(tvec);
	}

	fclose(fp);

	return nlines;
};


#endif /* SPACE_H_ */
